let utils = require('./utils');
let config = require('../config');
let path = require('path');

// var isProduction = process.env.NODE_ENV === 'production'
// for mp
let isProduction = true;
let cssLoaders = utils.cssLoaders({
    sourceMap: isProduction
      ? config.build.productionSourceMap
      : config.dev.cssSourceMap,
    extract: isProduction
  });

cssLoaders = Object.assign(cssLoaders, {
  html: path.resolve(__dirname, 'vue-template-loader.js')
});

module.exports = {
  loaders: cssLoaders,
  transformToRequire: {
    video: 'src',
    source: 'src',
    img: 'src',
    image: 'xlink:href'
  }
};
