const path = require('path');
const merge = require('webpack-merge');

let output = {
  pre: ['config'], //先执行config插件
  after: [],
  preAction: function (options) {
    logger.success('wefe-command-mpvue: ------------');
    return options;
  },
  options: [
    ['--watch', '调试模式']
  ],
  description: 'mpvue developer',
  action: function (options) {
    let baseConfig = options.config.toConfig();
    let userConfig = options.userConfig;

    let mpConfig = options.watch ? './build/webpack.dev.conf.js' : './build/webpack.prod.conf.js';
    let compiler = options.watch ? './build/dev-server.js' : './build/build.js';

    if (userConfig.plugins) {
      for (let i = 0; i < userConfig.plugins.length;) {
        let item = userConfig.plugins[i];
        if (item.constructor && /OpenBrowserPlugin/.test(item.constructor.toString())) {
          userConfig.plugins.splice(i, 1);
        } else {
          i++;
        }
      }
    }

    let modules = baseConfig.resolveLoader.modules || [];

    modules.push(path.resolve(__dirname, 'node_modules'));

    let cc = {
      resolve: {
        modules: baseConfig.resolve.modules
      },
      resolveLoader: {
        modules: modules
      }
    };

    userConfig = merge(cc, userConfig);

    userConfig = merge(require(mpConfig), userConfig);

    require(compiler).start(userConfig);

    return options;
  }
};

module.exports = output;